package macpre;

/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Société : </p>
 * @author non attribuable
 * @version 1.0
 */
//import antlr.*;
import org.antlr.runtime.*;

public class FormuleTex {

    PretexFrame monFrame;
    GestionTex maGestionTex;
    String laTraduction;
    boolean enTaillePolice, pasDAccents;
    byte couleurCourante, typeCourant;
    boolean enChaineCouleurs, nePasEcrire, nouvelleChaine;
    String laChaineCouleur = "", laChaineCourante = "";
    String laChaineNePasEcrire = "";
    boolean enDirect;
    int profondeur, profondeurMax;
    String[] chaineReserve;
    final int TAILLE_MAX = 70;
    String NEW_LINE = System.getProperty("line.separator"); //    = "\r\n";
    byte contexteCourant, attributCourant, genreCourant, tailleCourante;
    byte graisseCourante, policeCourante, formeCourante, policeActuelle;
    boolean enChangementDeGraisse, nouvelleChaineMath, allerEnRenvoi;
    int nombreDeRC;
    int[] positionDeRenvoi = new int[2];

    public FormuleTex(PretexFrame monFrame) {
        this.monFrame = monFrame;
    }

    void reset() {
        laTraduction = "";

        profondeur = 0;
        chaineReserve = new String[32];
        chaineReserve[0] = "";
        nouvelleChaine = false;

        genreCourant = Globale.GENRE_TEXTE;
        contexteCourant = Globale.CONTEXTE_TEXTE;
        attributCourant = Globale.ATTRIBUT_NORMAL;
        couleurCourante = Globale.COULEUR_TEXTE;
        typeCourant = Globale.TYPE_ORDINAIRE;

        policeCourante = 0;
        policeActuelle = 0;
        formeCourante = 0;
        graisseCourante = 0;
        tailleCourante = 0;

        enChangementDeGraisse = false;
        nouvelleChaineMath = false;
        nePasEcrire = false;
// pour la valeur de la couleur
        enChaineCouleurs = false;
// traduit en couleur
        enTaillePolice = false;

        laChaineCourante = "";
        laChaineCouleur = "";

        profondeurMax = 0;
//=== gestion des exceptions ===
        allerEnRenvoi = false;
        nombreDeRC = 0;
        positionDeRenvoi[0] = 0;
        positionDeRenvoi[1] = 0;
//============== bibtex ==============
    /*
        if(monFrame.monMenuTex.maBoiteLatex.lesBibFiles.equals(""))
        avecBibTeX = false;
        else
        avecBibTeX = true;
         */
    }

    /**
     * Enregistre la chaine actuelle et commence une nouvelle chaine courante.
     */
    void commenceNouvelleChaine() {
        if (laChaineCourante.equals("")) {
            nouvelleChaine = true;
            return;
        }
        if (nouvelleChaine) {
            return;
        }
        metLaChaine(laChaineCourante, "", "");
        laChaineCourante = "";
        nouvelleChaine = true;
    }

    String coupeAuBlancAvant(String laChaine) {
        int pos;
        String sousChaine = laChaine;

        pos = laChaine.indexOf(' ');
        if (pos >= 0) {
            sousChaine = laChaine.substring(0, pos + 1);
        }
        return sousChaine;
    }

    String coupeAuBlancApres(String laChaine) {
        int pos;
        String sousChaine = laChaine;

        pos = laChaine.indexOf(' ');
        if (pos >= 0) {
            sousChaine = laChaine.substring(pos + 1);
        }
        return sousChaine;
    }

    int remainder(int leNombre, int val) {
        int quot, reste;

        quot = leNombre / val;
        reste = leNombre - (quot * val);

        return reste;
    }

    void ecritChaineTeX(String laChaine) {
        String sousChaine = laChaine;
        String sousChaine2;
        int tailleDeLaLigne;

        /*        if (maGestionTex.titreAmettre) {
        maGestionTex.leTitreChaine += new String(laChaine);
        }
         */
        do {
            sousChaine2 = coupeAuBlancAvant(sousChaine);
            if (sousChaine2.equals(sousChaine)) {
                break;
            }
            laTraduction += sousChaine2;
            tailleDeLaLigne = laTraduction.length()
                    - laTraduction.lastIndexOf(NEW_LINE);
            if (tailleDeLaLigne > TAILLE_MAX) {
                laTraduction += NEW_LINE;
            }
            sousChaine = coupeAuBlancApres(sousChaine);
        } while (!sousChaine2.equals(sousChaine));

        laTraduction += sousChaine2;
        tailleDeLaLigne = laTraduction.length()
                - laTraduction.lastIndexOf(NEW_LINE);
        if ((tailleDeLaLigne > TAILLE_MAX)
                && (sousChaine2.endsWith(" "))) {
            laTraduction += NEW_LINE;
        }
    }

    void ecritChaineTeXDirect(String laChaine) {
        /*        if (maGestionTex.titreAmettre) {
        maGestionTex.leTitreChaine += new String(laChaine);
        }
         */ laTraduction += laChaine;
    }

    void empilelaChaine() {
        profondeur++;
        chaineReserve[profondeur] = "";
    }

    /**
     * Remplace la précédente par celle-ci.
     */
    void forceLaChaine(String laChaine, String avant, String apres) {
        chaineReserve[profondeur] = avant;
        nouvelleChaine = false;
        chaineReserve[profondeur] += laChaine;
        chaineReserve[profondeur] += apres;
    }

    /**
     * Met la chaine couleur sans dépiler.
     */
    void metLaChaineCouleur(String laChaine, String avant, String apres) {
        //if (nePasEcrire || maGestionTex.enFrameTitle) {
        if (nePasEcrire) {
            laChaineNePasEcrire = avant + laChaine + apres;
            return;
        }
        chaineReserve[profondeur] += avant;
        chaineReserve[profondeur] += laChaine;
        chaineReserve[profondeur] += apres;
    }

    /**
     * Met la chaine sans dépiler.
     */
    void metLaChaine(String laChaine, String avant, String apres) {
        if (nePasEcrire) {
            laChaineNePasEcrire = avant + laChaine + apres;
            return;
        }
        if (!nePasEcrire) {
            chaineReserve[profondeur] += avant;
        }
        if (nouvelleChaine) {
            nouvelleChaine = false;
            if (!nePasEcrire) {
                chaineReserve[profondeur] += laChaine;
            }
        }
        if (!nePasEcrire) {
            chaineReserve[profondeur] += apres;
        }
    }

    /**
     * Vide la chaine et repart
     */
    void videLesChaines() {
        ecritToutChaineReserve("", "", "");
        commenceNouvelleChaine();
    }

    /**
     * Met la chaine et dépile.
     */
    void depileLaChaine(String laChaine, String avant, String apres) {
        if (nePasEcrire) {
            laChaineNePasEcrire = avant + laChaine + apres;
            return;
        }
        profondeurMax = (profondeur > profondeurMax) ? profondeur : profondeurMax;
        if (profondeur > 0) {
            profondeur--;
        }
        if (!nePasEcrire) {
            chaineReserve[profondeur] += avant;
        }
        if (chaineReserve[profondeur + 1] != null) {
            chaineReserve[profondeur] += chaineReserve[profondeur + 1];
        }
        chaineReserve[profondeur + 1] = "";
        if (nouvelleChaine) {
            nouvelleChaine = false;
            if (!nePasEcrire) {
                chaineReserve[profondeur] += laChaine;
            }
        }
        if (!nePasEcrire) {
            chaineReserve[profondeur] += apres;
        }
        chaineReserve[profondeur + 1] = "";
    }

    void ecritToutChaineReserve(String laChaine, String avant, String apres) {
        profondeurMax = (profondeur > profondeurMax) ? profondeur : profondeurMax;
        if (profondeur > 0) {
            profondeur--;
        }
        if (chaineReserve[profondeur + 1] != null) {
            chaineReserve[profondeur] += avant + chaineReserve[profondeur + 1];
        } else {
            chaineReserve[profondeur] += avant;
        }
        chaineReserve[profondeur + 1] = "";
        if (nouvelleChaine) {
            nouvelleChaine = false;
            chaineReserve[profondeur] += laChaine;
        }
        chaineReserve[profondeur] += apres;
        for (int k = profondeurMax; k > 0; k--) {
            chaineReserve[k - 1] += chaineReserve[k];
            chaineReserve[k] = null;
        }
        profondeurMax = 0;
        profondeur = 0;
        ecritChaineTeX(chaineReserve[0]);
        chaineReserve[0] = "";
    }

//================================================================
    boolean traiteCetteChaine(String chaine) {
        laTraduction = "";
        reset();
        try {
            CharStream cs = new ANTLRStringStream(chaine);
            formuletoTeXLexer lexer = new formuletoTeXLexer(cs);
            CommonTokenStream tokens = new CommonTokenStream();
            tokens.setTokenSource(lexer);
            formuletoTeXParser parser = new formuletoTeXParser(tokens);
            parser.maFormuleTex = this;
            parser.file();

            /*FormuleToTeXLexer lexer = new FormuleToTeXLexer(
            //          new DataInputStream(new StringBufferInputStream(chaine)));
            new DataInputStream(new ByteArrayInputStream(chaine.getBytes("ISO8859_1"))));
            FormuleToTeXParser parser = new FormuleToTeXParser(lexer);
            parser.maFormuleTex = this;
            parser.file();*/
        } catch (Exception err) {
            System.err.println("Formule stream: " + err);
            System.err.println("in: " + chaine);
//            laTraduction += "Formula not translated.";
            //          System.err.println("Le fichier formule .tex n'a pu etre fait.");
            return true; // false;
        }
        return true;
    }

//================== Exception ===================
    void formuleException(int numero) {
        maGestionTex.formuleException(numero);
    }

    void gereException(int numero) {
        maGestionTex.gereException(numero);
    }

//================== fin Exception ===============
    void blanc() {
        if (enChaineCouleurs) {
            laChaineCouleur += ' ';
        } else if (enDirect) {
            laChaineCourante += ' ';
//      else if(enFormule || apresRC || enTableau || enTableauCase)
        } else if ((policeActuelle == 2) || (policeActuelle == 3)) {  // polices modifiables
            laChaineCourante += " ";
        } else {
            laChaineCourante += "\\ ";
        }
    }

    boolean traiteAccentDessus(String laChaine) {
        String maChaine = "";
        char[] lesCars = new char[1];
        char leCar;

        laChaine.getChars(0, 1, lesCars, 0);
        leCar = lesCars[0];

        switch (leCar) {
            case Globale.ROND_DESSUS:
                maChaine = "\\mathring ";
                break;
            case Globale.CARON:
                maChaine = "\\check ";
                break;
            case Globale.BREVE:
                maChaine = "\\breve ";
                break;
            case Globale.POINT_DESSUS:
                maChaine = "\\dot ";
                break;
            case Globale.DEUX_POINTS:
                maChaine = "\\ddot ";
                break;
            case Globale.DOUBLE_QUOTE:
                maChaine = "\\H ";
                break;
            case Globale.OGONEK:
                maChaine = "\\k ";
                break;
            case Globale.CEDILLE:
                maChaine = "\\c ";
                break;
        }
        if (enChaineCouleurs) {
            laChaineCouleur += maChaine;
        } else if (!enTaillePolice) {
            laChaineCourante += maChaine;
        } else {
            laChaineCourante += maChaine;
        }
        if (maChaine.equals("")) {
            return false;
        } else {
            return true;
        }
    }

    /**
     *
     */
    void traiteCaractere(String laChaine) {
        if(traiteAccentDessus(laChaine))
            return;
         if (enChaineCouleurs) {
            laChaineCouleur += laChaine;
        } else if (!enTaillePolice) {
            laChaineCourante += laChaine;
        } else {
            laChaineCourante += laChaine;
        }
    }

    /**
     *
     */
    void traiteCaractereReserve(String laChaine) {
        char leCar;
        String uneChaine = "";

        if (enChaineCouleurs) {
            return;
        }
        if (pasDAccents) {
            laChaineCourante += laChaine;
            return;
        }
        for (int k = 0; k < laChaine.length(); k++) {
            leCar = laChaine.charAt(k);
            uneChaine += caractereReserve(leCar);
        }
        laChaineCourante += uneChaine;
    }

    /**
     *
     */
    void traiteCaractereAutre(String laChaine) {
//    char leCar;
        String uneChaine = "";

        if (enChaineCouleurs) {
            return;
        }
        for (int k = 0; k < laChaine.length(); k++) {
//      leCar = laChaine.charAt(k);
            uneChaine += "???";
        }
        laChaineCourante += uneChaine;
    }

    /**
     * Renvoie la chaine TeX correspondant au caractère reservé.
     */
    String caractereReserve(char leCar) {
        if (enDirect) {
            return "" + leCar;
        }
        switch (leCar) {
            case '\\':
                return "\\backslash ";
            case '~':
                return "\\tilde ";
            case '^':
                return "\\hat ";
            default:
                return "\\" + leCar;
        }
    }

    void traiteCaractereAccentue(String laChaine) {
        String uneChaine = "";

        if (enChaineCouleurs) {
            return;
        }
        if (pasDAccents) {
            laChaineCourante += laChaine;
            return;
        }
        if (enDirect) {
            uneChaine = laChaine;
        } else {
            uneChaine = donneStandardFormule(laChaine);
        }
        laChaineCourante += uneChaine;
    }

    String donneStandardFormule(String laChaine) {
        int position;
        String uneChaine = "";

        for (int k = 0; k < laChaine.length(); k++) {
            position = (int) laChaine.charAt(k);
if (monFrame.monUserMath2 != null) {
            uneChaine += monFrame.monUserMath2.
texTraductionDesCars[Globale.ITALIC_MATH_USER][position];
}else{
           uneChaine += monFrame.monUserMath.
texTraductionDesCars[Globale.ITALIC_MATH_USER][position];

        }
        return uneChaine;
    }

    String donneStandard(String laChaine) {
        int position;
        String uneChaine = "";

        for (int k = 0; k < laChaine.length(); k++) {
            position = (int) laChaine.charAt(k);
            uneChaine += monFrame.monUserMath.texTraductionDesCars[Globale.ROMAN_USER][position];
        }
        return uneChaine;
    }

//================== fin de sauvetage ===============
    void traiteDebutCouleur() {
        if (!enChaineCouleurs) {
            metLaChaine(laChaineCourante, "", "");
            commenceNouvelleChaine();
            laChaineCouleur = new String();
            enChaineCouleurs = true;
        }
    }

    void traiteFinCouleur() {
        if (enChaineCouleurs) {
            enChaineCouleurs = false;
            if (monFrame.traduitEnCouleurs) {
                if (monFrame.optionTex == Globale.OPTION_BEAMER) {
                    if (!maGestionTex.enHeaderCouleur) {
                        metLaChaineCouleur(laChaineCouleur, "\\color[rgb]{", "} ");
                    }
                } else {
                    // metLaChaineCouleur(laChaineCouleur, "{\\couleur(", ") }");
                    metLaChaineCouleur(laChaineCouleur, "\\color[rgb]{", "} ");
                }
            }
        }
    }

//====================== contextes base ======================
    void chaineDirecte() {
//      depileLaChaine(laChaineCourante, "", "");
        ecritToutChaineReserve(laChaineCourante, "", "");
        videLesChaines();
        enDirect = true;
    }

    void finChaineDirecte() {
//      empilelaChaine();
        ecritToutChaineReserve(laChaineCourante, "", "");
//      depileLaChaine(laChaineCourante, "", "");
        videLesChaines();
        enDirect = false;
    }

    void contexteTexte() {
        contexteCourant = Globale.CONTEXTE_TEXTE;
        if (monFrame.optionTex == 0) {
            ecritToutChaineReserve(laChaineCourante, "", "\\rm ");
        }
        empilelaChaine();
    }

    void finContexteTexte() {
        depileLaChaine(laChaineCourante, "", "");
    }

//====================== attributs ======================
    void attributNormal() {
        attributCourant = Globale.ATTRIBUT_NORMAL;
        empilelaChaine();
    }

    void finAttributNormal() {
        depileLaChaine(laChaineCourante, "", "");
    }

    void entreeAttributIndice() {
    }

    void baseIndice() {
        attributCourant = Globale.EN_INDICE;
        empilelaChaine();
    }

    void indiceIndice() {
        depileLaChaine(laChaineCourante, "_{", "}");
    }

    void attributIndice() {
    }

    void baseExposant() {
        attributCourant = Globale.EN_EXPOSANT;
        empilelaChaine();
    }

    void exposantExposant() {
        depileLaChaine(laChaineCourante, "^{", "}");
    }

    void entreeAttributExposant() {
    }

    void attributExposant() {
    }

    void entreeAttributIndiceExposant() {
    }

    void baseIndiceExposant() {
        attributCourant = Globale.EN_INDICE;
        empilelaChaine();
    }

    void mixteIndice() {
        depileLaChaine(laChaineCourante, "_{", "}");
        attributCourant = Globale.EN_EXPOSANT;
        empilelaChaine();
    }

    void mixteExposant() {
        depileLaChaine(laChaineCourante, "^{", "}");
    }

    void attributIndiceExposant() {
    }

    void entreeSurligne() {
        attributCourant = Globale.EN_SURLIGNER;
        empilelaChaine();
    }

    void surligne() {
        depileLaChaine(laChaineCourante, "\\overline{", "}");
    }

    void entreeSouligne() {
        attributCourant = Globale.EN_SOULIGNER;
        empilelaChaine();
    }

    void souligne() {
        depileLaChaine(laChaineCourante, "\\underline{", "}");
    }

//====================== contextes references ======================
    void entreeLabelFormule() {
        contexteCourant = Globale.CONTEXTE_LABEL_FORMULE;
        metLaChaine(laChaineCourante, "", "");
    }

    void labelFormule() {
        laChaineCourante = laChaineCourante.trim();
        metLaChaine(laChaineCourante, "\\label{", "}");
        commenceNouvelleChaine();
    }//====================== tailles ======================
    boolean finitTaille;

    void metLaTaillePolice() {
        if ((contexteCourant != Globale.CONTEXTE_TEXTE)
                || (genreCourant != Globale.GENRE_TEXTE)) {
            laChaineCourante = "";
            return;
        }
        /*
        switch(genreCourant) {
        case Globale.GENRE_LA_FORMULE
        }

        if (laChaineCourante.equals("16")) {
        tailleCourante = Globale.TAILLE_NORMALE;
        //         depileLaChaine("{\\normalsize ", "", "");
        }
        else if (laChaineCourante.equals("6")) {
        tailleCourante = Globale.TAILLE_TINY;
        depileLaChaine("$\\mbox{\\tiny $", "", "");
        }
        else if (laChaineCourante.equals("8")) {
        tailleCourante = Globale.TAILLE_SCRIPT;
        depileLaChaine("$\\mbox{\\scriptsize $", "", "");
        }
        else if (laChaineCourante.equals("10")) {
        tailleCourante = Globale.TAILLE_FOOTNOTE;
        depileLaChaine("$\\mbox{\\footnotesize $", "", "");
        }
        else if (laChaineCourante.equals("12")) {
        tailleCourante = Globale.TAILLE_SMALL;
        depileLaChaine("$\\mbox{\\small $", "", "");
        }
        else if (laChaineCourante.equals("18")) {
        tailleCourante = Globale.TAILLE_LARGE;
        depileLaChaine("$\\mbox{\\large $", "", "");
        }
        else if (laChaineCourante.equals("20")) {
        tailleCourante = Globale.TAILLE_LARGE2;
        depileLaChaine("$\\mbox{\\Large $", "", "");
        }
        else if (laChaineCourante.equals("24")) {
        tailleCourante = Globale.TAILLE_LARGE3;
        depileLaChaine("$\\mbox{\\LARGE $", "", "");
        }
        else if (laChaineCourante.equals("28")) {
        tailleCourante = Globale.TAILLE_HUGE;
        depileLaChaine("$\\mbox{\\huge $", "", "");
        }
        else if (laChaineCourante.equals("32")) {
        tailleCourante = Globale.TAILLE_HUGE2;
        depileLaChaine("$\\mbox{\\Huge $", "", "");
        }
        laChaineCourante = "";
         */
    }

    void metFinALaTaillePolice() {
        if ((contexteCourant != Globale.CONTEXTE_TEXTE)
                || (genreCourant != Globale.GENRE_TEXTE)) {
            laChaineCourante = "";
            return;
        }
        /*
        if (!laChaineCourante.equals("16")) {
        depileLaChaine("$}$", "", "");
        }
         */ laChaineCourante = "";
    }

    void taillePolice() {
        enTaillePolice = true;
        finitTaille = false;
    }

    void finTaillePolice() {
        enTaillePolice = false;
        if (!finitTaille) {
            metLaTaillePolice();
        } else {
            metFinALaTaillePolice();
        }
    }

    void queuePolice() {
        finitTaille = true;
    }

    void tailleStandard() {
        tailleCourante = Globale.TAILLE_NORMALE;
// le standard on n'empile pas
        empilelaChaine();
    }

    void tailleRC() {
        tailleCourante = Globale.TAILLE_RC;
        empilelaChaine();
    }

    void finTailleTiny() {
    }

    void finTailleScript() {
    }

    void finTailleFootnote() {
    }

    void finTaillePetite() {
    }

    void finTailleRC() {
        depileLaChaine(laChaineCourante, "", "");
    }

    void finTailleStandard() {
// le standard on n'empile pas
        depileLaChaine(laChaineCourante, "", "");
//      metLaChaine(laChaineCourante, "", "");
    }

    void finTailleGrande() {
    }

    void finTailleGGrande() {
    }

    void finTailleGGGrande() {
    }

    void finTailleHuge() {
    }

    void finTailleHHuge() {
    }

    /**
     *
     */
    void ouvertureMath() {
        policeActuelle = 2;
        pasDAccents = true;
    }

    void ouvertureMath2() {
        policeActuelle = 3;
        pasDAccents = true;
    }

    void ouvertureGrecque() {
        pasDAccents = true;
    }

    void ouvertureBlackBd() {
        pasDAccents = true;
    }

    void ouvertureUs() {
        pasDAccents = true;
    }

    void mathBox(String laChaine) {
        if (enChaineCouleurs) {
            return;
        }
        laChaine = "\\mbox{" + laChaine + "}";
        nouvelleChaine = true;
        metLaChaine(laChaine, "", "");
    }

    void mathML(String laChaine) {
        if (enChaineCouleurs) {
            return;
        }
        char leCar = laChaine.charAt(0);
//    videLesChaines();
        switch (leCar) {
            case 'd':
                laChaine = "\\leq ";
                break;
            case 'e':
                laChaine = "\\geq ";
                break;
        }
        nouvelleChaine = true;
//    if(nePasEcrire)
        //    laChaineNePasEcrire += laChaine;
        //else {
        metLaChaine(laChaine, "", "");
//    }
//      laChaineCourante += laChaine;
    }

//=======================
    void policeFormule() {
    }

    boolean siPasNecessaire(byte police, int style) {
        return false;
    }

//=== roman ==
    void policeRoman(int style) {
// traiter la chaine courante ici !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// ne faire que si nécessaire
        if (siPasNecessaire(Globale.ROMAN, style)) {
            return;
        }
        gereLeStyle("{\\rm{", "{\\mathrm{", style, "}}");
        policeCourante = Globale.ROMAN;
    }

//=== italique ==
    void policeItalic(int style) {
// ne faire que si nécessaire
        if (siPasNecessaire(Globale.ITALIC, style)) {
            return;
        }
        gereLeStyle("", "", style, "");
        policeCourante = Globale.ITALIC;
    }

//=== Callig ==
    void policeCallig(int style) {
// ne faire que si nécessaire
        if (siPasNecessaire(Globale.CALLIGRAPHIC, style)) {
            return;
        }
        gereLeStyle("{\\mathcal{", "{\\mathcal{", style, "}}");
        policeCourante = Globale.CALLIGRAPHIC;
    }

//=== Smc ==
    void policeSmc(int style) {
// ne faire que si nécessaire
        if (siPasNecessaire(Globale.SMALLCAP, style)) {
            return;
        }
        gereLeStyle("{\\sc{", "{\\textsc{", style, "}}");
        policeCourante = Globale.SMALLCAP;
    }

//=== Goth ==
    void policeGoth(int style) {
// ne faire que si nécessaire
        if (siPasNecessaire(Globale.GOTHIC, style)) {
            return;
        }
        gereLeStyle("{\\goth{", "{\\mathfrak{", style, "}}");
        policeCourante = Globale.GOTHIC;
    }

//=== Tpw ==
    void policeTpw(int style) {
// ne faire que si nécessaire
        if (siPasNecessaire(Globale.TYPEWRITER, style)) {
            return;
        }
        gereLeStyle("{\\tt{", "{\\texttt{", style, "}}");
        policeCourante = Globale.TYPEWRITER;
    }

//=== Cy ==
    void policeCy(int style) {
// ne faire que si nécessaire
        if (siPasNecessaire(Globale.CYRILLIC, style)) {
            return;
        }
        gereLeStyle("{\\cyr{", "{\\cyr{", style, "}}");
        policeCourante = Globale.CYRILLIC;
    }

//============================ les maths ==
    void metCetteChaineEnPolice(String chaine, String finChaine,
            String policeTeX, String policeLaTeX) {
        if (monFrame.optionTex == 0) {
            metLaChaine(chaine, policeTeX, finChaine);
        } else {
            metLaChaine(chaine, policeLaTeX, finChaine);
        }
    }

    void gereCeMathStyle(String laChaine, int style) {
        switch (style) {
            case Globale.STYLE_NORMAL:
                metCetteChaineEnPolice(laChaine, "", "", "");
                return;
            case Globale.STYLE_PENCHE:

//          metCetteChaineEnPolice(laChaine, "}", "\\sl{", "\\textsl{");
                metCetteChaineEnPolice(laChaine, "}", "\\sl{", "{");
                return;
            case Globale.STYLE_GRAS:
                metCetteChaineEnPolice(laChaine, "}", "\\bf{", "\\mathbf{");
                return;
            case Globale.STYLE_PENCHE_GRAS:
                metCetteChaineEnPolice(laChaine, "}}", "\\sl{\\bf{",
                        //                               "\\textsl{\\mathbf{");
                        "{\\mathbf{");
                return;
        }
    }

    /*
    String retablitLesReserves(String laChaine) {
    if(laChaine.equals("\\tilde ")) {
    return "~";
    }
    if(laChaine.equals("\\backslash ")) {
    return "\\";
    }
    if(laChaine.equals("\\$")) {
    return "$";
    }
    if(laChaine.equals("\\#")) {
    return "#";
    }
    if(laChaine.equals("\\%")) {
    return "%";
    }
    if(laChaine.equals("\\&")) {
    return "&";
    }
    if(laChaine.equals("\\{")) {
    return "{";
    }
    if(laChaine.equals("\\}")) {
    return "}";
    }
    if(laChaine.equals("\\^")) {
    return "^";
    }
    if(laChaine.equals("\\_")) {
    return "_";
    }
    return laChaine;
    }
     */
    void policeNonModifiable(int style, int numPol) {
        int position;
        String laChaine = "";
// traiter la chaine courante ici !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        for (int k = 0; k < laChaineCourante.length(); k++) {
            position = (int) laChaineCourante.charAt(k);
            laChaine += monFrame.monUserMath.texTraductionDesCars[numPol][position];
        }
        gereCeMathStyle(laChaine, style);
        pasDAccents = false;
        laChaineCourante = "";
    }

    void policeModifiable(int style, int numPol) {
        int position;
        String laChaine = "";
// traiter la chaine courante ici !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        for (int k = 0; k < laChaineCourante.length(); k++) {
            position = (int) laChaineCourante.charAt(k);
// les blancs en formule deviennent "\ " donc il faut enlever le "\" pour avoir une bonne
// traduction dans les polices modifiables.
/*if((position == 92) && ((numPol == 2) || (numPol == 3))){
            continue;
            }*/
            laChaine += monFrame.monUserMath.texTraductionDesCars[numPol][position];
        }
        gereCeMathStyle(laChaine, style);
        pasDAccents = false;
        laChaineCourante = "";
    }

//==== Us ==
    void policeUs(int style) {
        policeModifiable(style, 0);
        policeCourante = Globale.USER;
    }

//=== grecque ==
    void policeGrecque(int style) {
        policeModifiable(style, 1);
        policeCourante = Globale.GRECQUE;
        /*      if(!enFormule) {
        ecritChaineTeX("$");
        enFormule = true;
        }
         */
    }

//=== Math ==
    void policeMath(int style) {
        policeModifiable(style, 2);
        policeCourante = Globale.MATHEMATIC;
        policeActuelle = 0;
    }

//=== Math2 ==
    void policeMath2(int style) {
        policeModifiable(style, 3);
        policeCourante = Globale.MATHEMATIC2;
        policeActuelle = 0;

    }

//=== Bbb ==
    void policeBlackBd(int style) {
        policeModifiable(style, 4);
        policeCourante = Globale.BLACKBOARD;
    }

//=============== fin polices ===============
//====================== formes ======================
    void formeUsuelle() {
        formeCourante = Globale.FORME_USUELLE;
// le standard on n'empile pas
        empilelaChaine();
    }

    void formePenchee() {
        formeCourante = Globale.FORME_PENCHEE;
        empilelaChaine();
    }

    void finFormeUsuelle() {
// le standard on n'empile pas
        depileLaChaine(laChaineCourante, "", "");
//      metLaChaine(laChaineCourante, "", "");
    }

    void finFormePenchee() {
//      depileLaChaine(laChaineCourante, "\\textsl{", "}");
        depileLaChaine(laChaineCourante, "{", "}");
    }

//====================== graisses ======================
    void graisseUsuelle() {
        graisseCourante = Globale.GRAISSE_USUELLE;
// le standard on n'empile pas
        empilelaChaine();
    }

    void graisseBold() {
        graisseCourante = Globale.GRAISSE_BOLD;
        empilelaChaine();
    }

    void finGraisseUsuelle() {
// le standard on n'empile pas
        depileLaChaine(laChaineCourante, "", "");
//      metLaChaine(laChaineCourante, "", "");
    }

    void finGraisseBold() {
        depileLaChaine(laChaineCourante, "\\mathbf{", "}");
    }

    /**====================== polices ======================
     * Sous controle : les formes, les graisses
     */
    /**
     * Suivant Latex ou Plain TeX.
     */
    void metCettePolice(String policeTeX, String policeLaTeX, String finChaine) {

        if (monFrame.optionTex == 0) {
            metLaChaine(laChaineCourante, policeTeX, finChaine);
        } else {
            metLaChaine(laChaineCourante, policeLaTeX, finChaine);
        }
    }

    void metCettePoliceEnSlanted(String policeTeX, String policeLaTeX,
            String finChaine) {
        if (monFrame.optionTex == 0) {
            metLaChaine(laChaineCourante, policeTeX + "{\\sl{",
                    finChaine + "}}");
        } else {
//        metLaChaine(laChaineCourante, policeLaTeX + "\\textsl{",
            metLaChaine(laChaineCourante, policeLaTeX + "{",
                    finChaine + "}");
        }
    }

    void metCettePoliceEnBold(String policeTeX, String policeLaTeX,
            String finChaine) {
        if (monFrame.optionTex == 0) {
            metLaChaine(laChaineCourante, policeTeX + "{\\bf{",
                    finChaine + "}}");
        } else {
            metLaChaine(laChaineCourante, policeLaTeX + "\\mathbf{",
                    finChaine + "}");
        }
    }

    void metCettePoliceEnSlantedBold(String policeTeX, String policeLaTeX,
            String finChaine) {
        if (monFrame.optionTex == 0) {
            metLaChaine(laChaineCourante, policeTeX + "{\\sl{\\bf ",
                    finChaine + "}}");
        } else {
//        metLaChaine(laChaineCourante, policeLaTeX + "\\mathsl{\\mathbf{",
            metLaChaine(laChaineCourante, policeLaTeX + "{\\mathbf{",
                    finChaine + "}}");
        }
    }

    void gereLeStyle(String policeTeX, String policeLaTeX, int style,
            String finChaine) {
        switch (style) {
            case Globale.STYLE_NORMAL:
                metCettePolice(policeTeX, policeLaTeX, finChaine);
                return;
            case Globale.STYLE_PENCHE:
                metCettePoliceEnSlanted(policeTeX, policeLaTeX, finChaine);
                return;
            case Globale.STYLE_GRAS:
                metCettePoliceEnBold(policeTeX, policeLaTeX, finChaine);
                return;
            case Globale.STYLE_PENCHE_GRAS:
                metCettePoliceEnSlantedBold(policeTeX, policeLaTeX, finChaine);
                return;
        }
    }    //====================== genres formules ===================
    int enContexteSpecial;
    int typeDeFormule;
    String enDisplayStyle = "";

    /**
     * Ecrit tout puis intitule les petites formules, ouvre une formule
     */
    void petiteFormule() {
        enContexteSpecial = 0;
        typeDeFormule = 1;
        genreCourant = Globale.GENRE_FORMULE;
    }

    void petiteFormuleDisplay() {
        enContexteSpecial = 0;
        typeDeFormule = 2;
        enDisplayStyle = "\\displaystyle ";
        genreCourant = Globale.GENRE_LA_PETITE_FORMULE_DISPLAY;
    }

    void formuleStandard() {
        enContexteSpecial = 0; // pour éviter le passage à la ligne en chapitre etc...
        typeDeFormule = 3;
        genreCourant = Globale.GENRE_FORMULE;
    }

    void formuleStandardNumbered() {
        enContexteSpecial = 0; // pour éviter le passage à la ligne en chapitre etc...
        typeDeFormule = 5;
        genreCourant = Globale.GENRE_LA_FORMULE_NUMBERED;
        /*if (monFrame.optionTex > 0) {
        //      metLaChaine("", NEW_LINE + "\\begin{equation} ", "");
        } else {
        //      metLaChaine("", "$$", "");
        }*/    }

    void formuleStandardDisplayNumbered() {
        enContexteSpecial = 0; // pour éviter le passage à la ligne en chapitre etc...
        typeDeFormule = 6;
        enDisplayStyle = "\\displaystyle ";
        genreCourant = Globale.GENRE_LA_FORMULE_DISPLAY_NUMBERED;
    }

    void formuleStandardDisplay() {
        enContexteSpecial = 0; // pour éviter le passage à la ligne en chapitre etc...
        typeDeFormule = 4;
        enDisplayStyle = "\\displaystyle ";
        genreCourant = Globale.GENRE_LA_FORMULE_DISPLAY;
    }

    /**
     * Ferme une formule
     */
    void finGenreFormule() {
        switch (typeDeFormule) {
            case 1:
            case 2:

//        ecritToutChaineReserve(laChaineCourante, "", "$");
                ecritToutChaineReserve(laChaineCourante, "", "");
                break;
            case 3:
            case 4:
                ecritToutChaineReserve(laChaineCourante, "", "");

//        ecritToutChaineReserve(laChaineCourante, "", "$$");
                break;
            case 5:
            case 6:
                ecritToutChaineReserve(laChaineCourante, "", "");

                /*      if (monFrame.optionTex > 0) {
                ecritToutChaineReserve(laChaineCourante, "",
                "\\end{equation}" + NEW_LINE);
                }
                else {
                ecritToutChaineReserve(laChaineCourante, "", "$$");
                }
                 */ break;
        }
        typeDeFormule = 0;
        enDisplayStyle = "";
        genreCourant = Globale.GENRE_TEXTE;
    }

    //======================== symboles ==============================
//=================== monos ================
    void entreeCorps() {
        depileLaChaine("", "", "");
    }

//====================================
    void entreeParExces() {
        metLaChaine("", "", "\\left\\lceil");
    }

    void parExces() {
        metLaChaine(laChaineCourante, "", "\\right\\rceil ");
    }

    void entreeParentheses() {
        metLaChaine("", "", enDisplayStyle + "\\left(");
    }

    void parentheses() {
        metLaChaine(laChaineCourante, "", "\\right) ");
    }

    void entreeCrochets() {
        metLaChaine("", "", enDisplayStyle + "\\left[");
    }

    void crochets() {
        metLaChaine(laChaineCourante, "", "\\right] ");
    }

    void entreeAccoladeOuvrante() {
        metLaChaine("", "", enDisplayStyle + "\\left\\lbrace");
    }

    void accoladeOuvrante() {
        metLaChaine(laChaineCourante, "", "\\right. ");
    }

    void entreeAccoladeFermante() {
        metLaChaine("", "", enDisplayStyle + "\\left.");
    }

    void accoladeFermante() {
        metLaChaine(laChaineCourante, "", "\\right\\rbrace ");
    }

    void entreeParDefaut() {
        metLaChaine("", "", enDisplayStyle + "\\left\\lfloor");
    }

    void parDefaut() {
        metLaChaine(laChaineCourante, "", "\\right\\rfloor ");
    }

    void entreeProdScalaire() {
        metLaChaine("", "", enDisplayStyle + "\\left\\langle");
    }

    void prodScalaire() {
        metLaChaine(laChaineCourante, "", "\\right\\rangle ");
    }

    void entreeNorme() {
        metLaChaine("", "", enDisplayStyle + "\\left\\Vert");
    }

    void norme() {
        metLaChaine(laChaineCourante, "", "\\right\\Vert ");
    }

    void entreeRacine() {
        metLaChaine("", "", enDisplayStyle + "\\sqrt");
    }

    void racine() {
        metLaChaine(laChaineCourante, "", "");
    }

    void entreeBarre() {
        metLaChaine("", "", enDisplayStyle + "\\overline");
    }

    void barre() {
        metLaChaine(laChaineCourante, "", "");
    }

    void entreeVecteur() {
        metLaChaine("", "", enDisplayStyle + "\\overrightarrow");
    }

    void vecteur() {
        metLaChaine(laChaineCourante, "", "");
    }

    void entreeValeurAbsolue() {
        metLaChaine("", "", enDisplayStyle + "\\left\\vert");
    }

    void valeurAbsolue() {
        metLaChaine(laChaineCourante, "", "\\right\\vert ");
    }

    void entreeExposant() {
        metLaChaine("", "", "^");
    }

    void exposant() {
        metLaChaine(laChaineCourante, "", "");
    }

    void entreeIndice() {
        metLaChaine("", "", "_");
    }

    void indice() {
        metLaChaine(laChaineCourante, "", "");
    }

//=================== duos ================
    void entreeFraction() {
        metLaChaine("", "", "\\frac");
    }

    void entreeGenFrac() {
        metLaChaine("", "", "\\genfrac{}{}{0pt}{}");
    }

    void entreeParDessus() {
        metLaChaine("", "", "\\overset");
    }

    void entreeParDessous() {
        metLaChaine("", "", "\\underset");
    }

    void entreeAccoladeHaute() {
        metLaChaine("", "", enDisplayStyle + "\\overbrace");
    }

    void entreeAccoladeBasse() {
        metLaChaine("", "", enDisplayStyle + "\\underbrace");
    }

    void entreeRacineK() {
        metLaChaine("", "", enDisplayStyle + "\\root");
    }

    void numerateurAccHaute() {
        metLaChaine(laChaineCourante, "", "^");
    }

    void numerateurAccBasse() {
        metLaChaine(laChaineCourante, "", "_");
    }

    void numerateurRacineK() {
        metLaChaine(laChaineCourante, "", "\\of");
    }

    void numerateur() {
    }

    void denominateur() {
    }

    void denominateurRacineK() {
        metLaChaine(laChaineCourante, "", "");
    }

    void denominateurAccHaute() {
        metLaChaine(laChaineCourante, "", "");
    }

    void denominateurAccBasse() {
        metLaChaine(laChaineCourante, "", "");
    }

    void duo() {
        metLaChaine(laChaineCourante, "", "");
    }

//=================== trios ===============
    void entreeContentIdentifierShift() {
        metLaChaine(laChaineCourante, "\\hfill{", "");
    }

    void sortieContentIdentifierShift() {
        metLaChaine(laChaineCourante, "", "}\\hfill ");
    }

    void entreeContentIdentifier() {
        metLaChaine(laChaineCourante, "{", "");
//        metLaChaine(laChaineCourante, "{" + enDisplayStyle, "");
    }

    void sortieContentIdentifier() {
        metLaChaine(laChaineCourante, "", "}");
    }

    void entreeSymbole() {
        metLaChaine(laChaineCourante, "", "");
    }

    void entreeBorneInf() {
        metLaChaine("", "", "_{");
    }

    void entreeBorneSup() {
        metLaChaine(laChaineCourante, "", "}^{");
    }

    void entreeBorneCor() {
        metLaChaine(laChaineCourante, "", "}{");
    }

    void sortieBorneCor() {
        metLaChaine(laChaineCourante, bdVariable, "}");
        bdVariable = "";
    }
    String bdVariable = "";
    boolean enBvar = false;

    void entreeBoundedVariable() {
        nePasEcrire = true;
        enBvar = true;
    }

    void boundedVariable() {
        enBvar = false;
        nePasEcrire = false;
        bdVariable = "\\,d" + laChaineNePasEcrire + "";
        laChaineNePasEcrire = "";
//      metLaChaine(laChaineCourante, "\\,d", "}");
    }

    void finalMath() {
        metLaChaine(laChaineCourante, "", "");
    }

    void finTrio() {
        metLaChaine(laChaineCourante, "", "}");
    }

//================
    void entreeUnion() {
        metLaChaine("", "", enDisplayStyle + "\\bigcup");
    }

    void entreeSpan() {
        metLaChaine("", "", enDisplayStyle + "\\bigvee");
    }

    void entreeIntersection() {
        metLaChaine("", "", enDisplayStyle + "\\bigcap");
    }

    void entreeIntegrale() {
        metLaChaine("", "", enDisplayStyle + "\\int");
    }

    void entreeProduitInfini() {
        metLaChaine("", "", enDisplayStyle + "\\prod");
    }

    void entreeSommeDirecte() {
        metLaChaine("", "", enDisplayStyle + "\\bigoplus");
    }

    void entreeProduitTensoriel() {
        metLaChaine("", "", enDisplayStyle + "\\bigotimes");
    }

    void entreeProduitVectoriel() {
        metLaChaine("", "", enDisplayStyle + "\\bigwedge");
    }

    void entreeSigma() {
        metLaChaine("", "", enDisplayStyle + "\\sum");
    }//================ matrice =============
    boolean avecBorne, premiereEntree;

    void entreeMatrice() {
        if ((monFrame.optionTex == Globale.OPTION_BEAMER)
                || //                (monFrame.optionTex == Globale.OPTION_LATEX) ||
                (monFrame.optionTex == Globale.OPTION_AMSTEX)) {
            metLaChaine(laChaineCourante, "", NEW_LINE + "\\begin{matrix}" + NEW_LINE);
        } else {
            metLaChaine(laChaineCourante, "", "\\matrix{");
        }
        premiereEntree = true;
    }

    void borneLigne() {
        if (avecBorne) {
            metLaChaine(laChaineCourante, "", "\\cr ");
        }
        avecBorne = false;
        premiereEntree = true;
    }

    void borneEntree() {
        if (!premiereEntree) {
            metLaChaine(laChaineCourante, "&", "");
        } else {
            premiereEntree = false;
        }
        avecBorne = true;
    }

    void matrice() {
        if ((monFrame.optionTex == Globale.OPTION_BEAMER)
                || //                (monFrame.optionTex == Globale.OPTION_LATEX) ||
                (monFrame.optionTex == Globale.OPTION_AMSTEX)) {
            metLaChaine(laChaineCourante, "", NEW_LINE + "\\end{matrix}" + NEW_LINE);
        } else {
            metLaChaine(laChaineCourante, "", "}");
        }
    }

    void unShift() {
        metLaChaine(laChaineCourante, "\\hfill ", "");
    }

    void mathAcc(String chaine) {
        if (chaine.equals("barre")) {
            laChaineCourante += "\\bar ";
        } else if (chaine.equals("breve")) {
            laChaineCourante += "\\breve ";
        } else if (chaine.equals("point")) {
            laChaineCourante += "\\dot ";
        } else if (chaine.equals("rond")) {
            laChaineCourante += "\\mathring ";
        } else if (chaine.equals("cedille")) {
            laChaineCourante += "\\c ";
        } else if (chaine.equals("dquote")) {
            laChaineCourante += "\\H ";
        } else if (chaine.equals("ogonek")) {
            laChaineCourante += "\\k ";
        } else if (chaine.equals("caron")) {
            laChaineCourante += "\\check ";
        } else if (chaine.equals("dpoint")) {
            laChaineCourante += "\\ddot ";
        }
    }
//=============================== fin ==============================
}
